--liquibase formatted sql
--changeset stv:100078 dbms:PostgreSQL endDelimiter:^

DO $$
  DECLARE _inspection_date TIMESTAMP;
BEGIN
  DECLARE c RECORD;
  BEGIN
    FOR c IN
        SELECT  inspection_date, inspection_id 
        FROM    inspection  
    LOOP
      _inspection_date = c.inspection_date; 
      IF (_inspection_date IS NULL)
      THEN
        _inspection_date = (SELECT documentreal_date
                            FROM   documentreal
                            WHERE  documentreal_id = c.inspection_id);
        UPDATE inspection SET
          inspection_date = _inspection_date
        WHERE inspection_id = c.inspection_id;
      END IF;    
    END LOOP;
  END;
END $$;
^

ALTER TABLE inspection ALTER COLUMN inspection_date SET NOT NULL^
