    CREATE TABLE administrativeobject(
	administrativeobject_id INTEGER NOT NULL,
	administrativeobject_name VARCHAR(255) NOT NULL,
	company_id INTEGER NOT NULL,
	administrativeobject_address VARCHAR(255),
    administrativeobject_year int4 NULL,
    administrativeobject_floorcount int4 NULL,
    administrativeobject_square float8 NULL,
    administrativeobject_coolsystem int4 NULL DEFAULT 0,
    foundationtype_id int4 NULL,
    CONSTRAINT administrativeobject_pk PRIMARY KEY (administrativeobject_id)
);
CREATE SEQUENCE administrativeobject_id_gen AS INTEGER START WITH 1 INCREMENT BY 1;
ALTER SEQUENCE administrativeobject_id_gen OWNED BY administrativeobject.administrativeobject_id;
ALTER TABLE administrativeobject ADD UNIQUE (administrativeobject_name,administrativeobject_id);

CREATE VIEW ft_administrativeobject
AS
SELECT
	administrativeobject_id,
	CAST(
		trim(administrativeobject_name)||' '||coalesce(administrativeobject_address,'')
		AS varchar(520)
	) AS fulltext
FROM administrativeobject;

