CREATE TABLE inspectionelement(
	inspectionelement_id INTEGER NOT NULL,
	inspection_id INTEGER NOT NULL,
	existflag_id INTEGER NOT NULL,
	element_id INTEGER NOT NULL,
	defect_id INTEGER,
	inspectionelement_result VARCHAR(400) NOT NULL,
	inspectionelement_note VARCHAR(255),
    CONSTRAINT inspectionelement_pk PRIMARY KEY (inspectionelement_id)
);
CREATE SEQUENCE inspectionelement_id_gen AS INTEGER START WITH 1 INCREMENT BY 1;
ALTER SEQUENCE inspectionelement_id_gen OWNED BY inspectionelement.inspectionelement_id;

CREATE VIEW ft_inspectionelement
AS
SELECT
	inspectionelement_id,
	CAST(
		trim(inspectionelement_result)||' '||coalesce(inspectionelement_note,'')
		AS varchar(665)
	) AS fulltext
FROM inspectionelement;

CREATE TABLE inspectionelementappendix(
	inspectionelementappendix_id INTEGER NOT NULL,
	inspectionelement_id INTEGER NOT NULL,
	appendix_id INTEGER NOT NULL,
    CONSTRAINT inspectionelementappendix_pk PRIMARY KEY (inspectionelementappendix_id)
);
CREATE SEQUENCE inspectionelementappendix_id_gen AS INTEGER START WITH 4 INCREMENT BY 1;
ALTER SEQUENCE inspectionelementappendix_id_gen OWNED BY inspectionelementappendix.inspectionelementappendix_id;
ALTER TABLE inspectionelementappendix ADD UNIQUE (inspectionelement_id,appendix_id);

INSERT INTO inspectionelementappendix VALUES(1, 1, 1);
INSERT INTO inspectionelementappendix VALUES(2, 2, 1);
INSERT INTO inspectionelementappendix VALUES(3, 1, 2);